from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry import object_events_pb2 as _object_events_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ContactInfoRequest(_message.Message):
    __slots__ = ("contact_id", "contact_history_id", "contact_snapshot_id")
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    CONTACT_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    contact_id: _contact_common_types_pb2.ContactId
    contact_history_id: _contact_common_types_pb2.ContactHistoryId
    contact_snapshot_id: _common_types_pb2.SnapshotId
    def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., contact_history_id: _Optional[_Union[_contact_common_types_pb2.ContactHistoryId, _Mapping]] = ..., contact_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ...) -> None: ...

class ContactInfoReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_handle", "contact_id", "contact_history_id", "snapshot_id", "name", "organization", "place", "telephone", "fax", "emails", "notify_emails", "vat_identification_number", "additional_identifier", "publish", "mailing_address", "billing_address", "shipping_address1", "shipping_address2", "shipping_address3", "warning_letter", "events", "sponsoring_registrar")
        class PublishEntry(_message.Message):
            __slots__ = ("key", "value")
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: bool
            def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
        CONTACT_HANDLE_FIELD_NUMBER: _ClassVar[int]
        CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
        CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
        PLACE_FIELD_NUMBER: _ClassVar[int]
        TELEPHONE_FIELD_NUMBER: _ClassVar[int]
        FAX_FIELD_NUMBER: _ClassVar[int]
        EMAILS_FIELD_NUMBER: _ClassVar[int]
        NOTIFY_EMAILS_FIELD_NUMBER: _ClassVar[int]
        VAT_IDENTIFICATION_NUMBER_FIELD_NUMBER: _ClassVar[int]
        ADDITIONAL_IDENTIFIER_FIELD_NUMBER: _ClassVar[int]
        PUBLISH_FIELD_NUMBER: _ClassVar[int]
        MAILING_ADDRESS_FIELD_NUMBER: _ClassVar[int]
        BILLING_ADDRESS_FIELD_NUMBER: _ClassVar[int]
        SHIPPING_ADDRESS1_FIELD_NUMBER: _ClassVar[int]
        SHIPPING_ADDRESS2_FIELD_NUMBER: _ClassVar[int]
        SHIPPING_ADDRESS3_FIELD_NUMBER: _ClassVar[int]
        WARNING_LETTER_FIELD_NUMBER: _ClassVar[int]
        EVENTS_FIELD_NUMBER: _ClassVar[int]
        SPONSORING_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
        contact_handle: _contact_common_types_pb2.ContactHandle
        contact_id: _contact_common_types_pb2.ContactId
        contact_history_id: _contact_common_types_pb2.ContactHistoryId
        snapshot_id: _common_types_pb2.SnapshotId
        name: str
        organization: str
        place: _common_types_pb2.PlaceAddress
        telephone: _common_types_pb2.PhoneNumber
        fax: _common_types_pb2.PhoneNumber
        emails: _containers.RepeatedCompositeFieldContainer[_common_types_pb2.EmailAddress]
        notify_emails: _containers.RepeatedCompositeFieldContainer[_common_types_pb2.EmailAddress]
        vat_identification_number: _common_types_pb2.VatIdentificationNumber
        additional_identifier: _contact_common_types_pb2.ContactAdditionalIdentifier
        publish: _containers.ScalarMap[str, bool]
        mailing_address: _contact_common_types_pb2.ContactAddress
        billing_address: _contact_common_types_pb2.ContactAddress
        shipping_address1: _contact_common_types_pb2.ContactAddress
        shipping_address2: _contact_common_types_pb2.ContactAddress
        shipping_address3: _contact_common_types_pb2.ContactAddress
        warning_letter: _contact_common_types_pb2.WarningLetter
        events: _object_events_pb2.ObjectEvents
        sponsoring_registrar: _registrar_common_types_pb2.RegistrarHandle
        def __init__(self, contact_handle: _Optional[_Union[_contact_common_types_pb2.ContactHandle, _Mapping]] = ..., contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., contact_history_id: _Optional[_Union[_contact_common_types_pb2.ContactHistoryId, _Mapping]] = ..., snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., name: _Optional[str] = ..., organization: _Optional[str] = ..., place: _Optional[_Union[_common_types_pb2.PlaceAddress, _Mapping]] = ..., telephone: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., fax: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., emails: _Optional[_Iterable[_Union[_common_types_pb2.EmailAddress, _Mapping]]] = ..., notify_emails: _Optional[_Iterable[_Union[_common_types_pb2.EmailAddress, _Mapping]]] = ..., vat_identification_number: _Optional[_Union[_common_types_pb2.VatIdentificationNumber, _Mapping]] = ..., additional_identifier: _Optional[_Union[_contact_common_types_pb2.ContactAdditionalIdentifier, _Mapping]] = ..., publish: _Optional[_Mapping[str, bool]] = ..., mailing_address: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., billing_address: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., shipping_address1: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., shipping_address2: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., shipping_address3: _Optional[_Union[_contact_common_types_pb2.ContactAddress, _Mapping]] = ..., warning_letter: _Optional[_Union[_contact_common_types_pb2.WarningLetter, _Mapping]] = ..., events: _Optional[_Union[_object_events_pb2.ObjectEvents, _Mapping]] = ..., sponsoring_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist", "invalid_data", "invalid_snapshot")
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
        invalid_data: _error_types_pb2.InvalidData
        invalid_snapshot: _error_types_pb2.InvalidSnapshot
        def __init__(self, contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_error_types_pb2.InvalidData, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ContactInfoReply.Data
    exception: ContactInfoReply.Exception
    def __init__(self, data: _Optional[_Union[ContactInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ContactInfoReply.Exception, _Mapping]] = ...) -> None: ...

class BatchContactInfoRequest(_message.Message):
    __slots__ = ("requests",)
    REQUESTS_FIELD_NUMBER: _ClassVar[int]
    requests: _containers.RepeatedCompositeFieldContainer[ContactInfoRequest]
    def __init__(self, requests: _Optional[_Iterable[_Union[ContactInfoRequest, _Mapping]]] = ...) -> None: ...

class BatchContactInfoReply(_message.Message):
    __slots__ = ("data",)
    class Data(_message.Message):
        __slots__ = ("replies",)
        class BatchReply(_message.Message):
            __slots__ = ("data", "error")
            DATA_FIELD_NUMBER: _ClassVar[int]
            ERROR_FIELD_NUMBER: _ClassVar[int]
            data: ContactInfoReply.Data
            error: BatchContactInfoReply.Error
            def __init__(self, data: _Optional[_Union[ContactInfoReply.Data, _Mapping]] = ..., error: _Optional[_Union[BatchContactInfoReply.Error, _Mapping]] = ...) -> None: ...
        REPLIES_FIELD_NUMBER: _ClassVar[int]
        replies: _containers.RepeatedCompositeFieldContainer[BatchContactInfoReply.Data.BatchReply]
        def __init__(self, replies: _Optional[_Iterable[_Union[BatchContactInfoReply.Data.BatchReply, _Mapping]]] = ...) -> None: ...
    class Error(_message.Message):
        __slots__ = ("request", "exception")
        REQUEST_FIELD_NUMBER: _ClassVar[int]
        EXCEPTION_FIELD_NUMBER: _ClassVar[int]
        request: ContactInfoRequest
        exception: ContactInfoReply.Exception
        def __init__(self, request: _Optional[_Union[ContactInfoRequest, _Mapping]] = ..., exception: _Optional[_Union[ContactInfoReply.Exception, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: BatchContactInfoReply.Data
    def __init__(self, data: _Optional[_Union[BatchContactInfoReply.Data, _Mapping]] = ...) -> None: ...

class ContactIdRequest(_message.Message):
    __slots__ = ("contact_handle",)
    CONTACT_HANDLE_FIELD_NUMBER: _ClassVar[int]
    contact_handle: _contact_common_types_pb2.ContactHandle
    def __init__(self, contact_handle: _Optional[_Union[_contact_common_types_pb2.ContactHandle, _Mapping]] = ...) -> None: ...

class ContactIdReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_id", "contact_history_id")
        CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
        CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        contact_id: _contact_common_types_pb2.ContactId
        contact_history_id: _contact_common_types_pb2.ContactHistoryId
        def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., contact_history_id: _Optional[_Union[_contact_common_types_pb2.ContactHistoryId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist",)
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
        def __init__(self, contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ContactIdReply.Data
    exception: ContactIdReply.Exception
    def __init__(self, data: _Optional[_Union[ContactIdReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ContactIdReply.Exception, _Mapping]] = ...) -> None: ...
