from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class SearchContactRequest(_message.Message):
    __slots__ = ("query_values", "limit", "searched_items")
    QUERY_VALUES_FIELD_NUMBER: _ClassVar[int]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
    query_values: _containers.RepeatedScalarFieldContainer[str]
    limit: int
    searched_items: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, query_values: _Optional[_Iterable[str]] = ..., limit: _Optional[int] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...

class SearchContactHistoryRequest(_message.Message):
    __slots__ = ("query_values", "max_number_of_contacts", "data_valid_from", "data_valid_to", "searched_items")
    QUERY_VALUES_FIELD_NUMBER: _ClassVar[int]
    MAX_NUMBER_OF_CONTACTS_FIELD_NUMBER: _ClassVar[int]
    DATA_VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    DATA_VALID_TO_FIELD_NUMBER: _ClassVar[int]
    SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
    query_values: _containers.RepeatedScalarFieldContainer[str]
    max_number_of_contacts: int
    data_valid_from: _timestamp_pb2.Timestamp
    data_valid_to: _timestamp_pb2.Timestamp
    searched_items: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, query_values: _Optional[_Iterable[str]] = ..., max_number_of_contacts: _Optional[int] = ..., data_valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., data_valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...

class SearchContactReply(_message.Message):
    __slots__ = ("data",)
    class Data(_message.Message):
        __slots__ = ("results", "estimated_total", "searched_items")
        class Result(_message.Message):
            __slots__ = ("object_id", "matched_items")
            OBJECT_ID_FIELD_NUMBER: _ClassVar[int]
            MATCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
            object_id: _contact_common_types_pb2.ContactId
            matched_items: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, object_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., matched_items: _Optional[_Iterable[str]] = ...) -> None: ...
        class FuzzyValue(_message.Message):
            __slots__ = ("lower_estimate", "upper_estimate")
            LOWER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            UPPER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            lower_estimate: int
            upper_estimate: int
            def __init__(self, lower_estimate: _Optional[int] = ..., upper_estimate: _Optional[int] = ...) -> None: ...
        RESULTS_FIELD_NUMBER: _ClassVar[int]
        ESTIMATED_TOTAL_FIELD_NUMBER: _ClassVar[int]
        SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
        results: _containers.RepeatedCompositeFieldContainer[SearchContactReply.Data.Result]
        estimated_total: SearchContactReply.Data.FuzzyValue
        searched_items: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, results: _Optional[_Iterable[_Union[SearchContactReply.Data.Result, _Mapping]]] = ..., estimated_total: _Optional[_Union[SearchContactReply.Data.FuzzyValue, _Mapping]] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: SearchContactReply.Data
    def __init__(self, data: _Optional[_Union[SearchContactReply.Data, _Mapping]] = ...) -> None: ...

class SearchContactHistoryReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("results", "estimated_total", "searched_items")
        class Result(_message.Message):
            __slots__ = ("object_id", "histories")
            class HistoryPeriod(_message.Message):
                __slots__ = ("matched_items", "valid_from", "valid_to", "contact_history_ids")
                MATCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
                VALID_FROM_FIELD_NUMBER: _ClassVar[int]
                VALID_TO_FIELD_NUMBER: _ClassVar[int]
                CONTACT_HISTORY_IDS_FIELD_NUMBER: _ClassVar[int]
                matched_items: _containers.RepeatedScalarFieldContainer[str]
                valid_from: _timestamp_pb2.Timestamp
                valid_to: _timestamp_pb2.Timestamp
                contact_history_ids: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactHistoryId]
                def __init__(self, matched_items: _Optional[_Iterable[str]] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., contact_history_ids: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactHistoryId, _Mapping]]] = ...) -> None: ...
            OBJECT_ID_FIELD_NUMBER: _ClassVar[int]
            HISTORIES_FIELD_NUMBER: _ClassVar[int]
            object_id: _contact_common_types_pb2.ContactId
            histories: _containers.RepeatedCompositeFieldContainer[SearchContactHistoryReply.Data.Result.HistoryPeriod]
            def __init__(self, object_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., histories: _Optional[_Iterable[_Union[SearchContactHistoryReply.Data.Result.HistoryPeriod, _Mapping]]] = ...) -> None: ...
        class FuzzyValue(_message.Message):
            __slots__ = ("lower_estimate", "upper_estimate")
            LOWER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            UPPER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            lower_estimate: int
            upper_estimate: int
            def __init__(self, lower_estimate: _Optional[int] = ..., upper_estimate: _Optional[int] = ...) -> None: ...
        RESULTS_FIELD_NUMBER: _ClassVar[int]
        ESTIMATED_TOTAL_FIELD_NUMBER: _ClassVar[int]
        SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
        results: _containers.RepeatedCompositeFieldContainer[SearchContactHistoryReply.Data.Result]
        estimated_total: SearchContactHistoryReply.Data.FuzzyValue
        searched_items: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, results: _Optional[_Iterable[_Union[SearchContactHistoryReply.Data.Result, _Mapping]]] = ..., estimated_total: _Optional[_Union[SearchContactHistoryReply.Data.FuzzyValue, _Mapping]] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("chronology_violation",)
        class ChronologyViolation(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        CHRONOLOGY_VIOLATION_FIELD_NUMBER: _ClassVar[int]
        chronology_violation: SearchContactHistoryReply.Exception.ChronologyViolation
        def __init__(self, chronology_violation: _Optional[_Union[SearchContactHistoryReply.Exception.ChronologyViolation, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: SearchContactHistoryReply.Data
    exception: SearchContactHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[SearchContactHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[SearchContactHistoryReply.Exception, _Mapping]] = ...) -> None: ...

class SuggestContactsRequest(_message.Message):
    __slots__ = ("query",)
    QUERY_FIELD_NUMBER: _ClassVar[int]
    query: str
    def __init__(self, query: _Optional[str] = ...) -> None: ...

class SuggestContactsReply(_message.Message):
    __slots__ = ("data",)
    class Data(_message.Message):
        __slots__ = ("contacts",)
        class Contact(_message.Message):
            __slots__ = ("ref", "additional_identifier")
            REF_FIELD_NUMBER: _ClassVar[int]
            ADDITIONAL_IDENTIFIER_FIELD_NUMBER: _ClassVar[int]
            ref: _contact_common_types_pb2.ContactRef
            additional_identifier: _contact_common_types_pb2.ContactAdditionalIdentifier
            def __init__(self, ref: _Optional[_Union[_contact_common_types_pb2.ContactRef, _Mapping]] = ..., additional_identifier: _Optional[_Union[_contact_common_types_pb2.ContactAdditionalIdentifier, _Mapping]] = ...) -> None: ...
        CONTACTS_FIELD_NUMBER: _ClassVar[int]
        contacts: _containers.RepeatedCompositeFieldContainer[SuggestContactsReply.Data.Contact]
        def __init__(self, contacts: _Optional[_Iterable[_Union[SuggestContactsReply.Data.Contact, _Mapping]]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: SuggestContactsReply.Data
    def __init__(self, data: _Optional[_Union[SuggestContactsReply.Data, _Mapping]] = ...) -> None: ...
