from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.contact_representative import contact_representative_common_types_pb2 as _contact_representative_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ContactRepresentativeInfoRequest(_message.Message):
    __slots__ = ("id", "history_id", "contact_id")
    ID_FIELD_NUMBER: _ClassVar[int]
    HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    id: _contact_representative_common_types_pb2.ContactRepresentativeId
    history_id: _contact_representative_common_types_pb2.ContactRepresentativeHistoryId
    contact_id: _contact_common_types_pb2.ContactId
    def __init__(self, id: _Optional[_Union[_contact_representative_common_types_pb2.ContactRepresentativeId, _Mapping]] = ..., history_id: _Optional[_Union[_contact_representative_common_types_pb2.ContactRepresentativeHistoryId, _Mapping]] = ..., contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ...) -> None: ...

class ContactRepresentativeInfoReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_representative",)
        CONTACT_REPRESENTATIVE_FIELD_NUMBER: _ClassVar[int]
        contact_representative: _contact_representative_common_types_pb2.ContactRepresentativeInfo
        def __init__(self, contact_representative: _Optional[_Union[_contact_representative_common_types_pb2.ContactRepresentativeInfo, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_representative_does_not_exist",)
        class ContactRepresentativeDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        CONTACT_REPRESENTATIVE_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        contact_representative_does_not_exist: ContactRepresentativeInfoReply.Exception.ContactRepresentativeDoesNotExist
        def __init__(self, contact_representative_does_not_exist: _Optional[_Union[ContactRepresentativeInfoReply.Exception.ContactRepresentativeDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ContactRepresentativeInfoReply.Data
    exception: ContactRepresentativeInfoReply.Exception
    def __init__(self, data: _Optional[_Union[ContactRepresentativeInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ContactRepresentativeInfoReply.Exception, _Mapping]] = ...) -> None: ...

class CreateContactRepresentativeRequest(_message.Message):
    __slots__ = ("contact_id", "name", "organization", "place", "telephone", "email", "log_entry_id")
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
    PLACE_FIELD_NUMBER: _ClassVar[int]
    TELEPHONE_FIELD_NUMBER: _ClassVar[int]
    EMAIL_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    contact_id: _contact_common_types_pb2.ContactId
    name: str
    organization: str
    place: _common_types_pb2.PlaceAddress
    telephone: _common_types_pb2.PhoneNumber
    email: _common_types_pb2.EmailAddress
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., name: _Optional[str] = ..., organization: _Optional[str] = ..., place: _Optional[_Union[_common_types_pb2.PlaceAddress, _Mapping]] = ..., telephone: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., email: _Optional[_Union[_common_types_pb2.EmailAddress, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class CreateContactRepresentativeReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_representative",)
        CONTACT_REPRESENTATIVE_FIELD_NUMBER: _ClassVar[int]
        contact_representative: _contact_representative_common_types_pb2.ContactRepresentativeInfo
        def __init__(self, contact_representative: _Optional[_Union[_contact_representative_common_types_pb2.ContactRepresentativeInfo, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_representative_already_exists", "contact_does_not_exist", "invalid_data")
        class ContactRepresentativeAlreadyExists(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class ContactDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        CONTACT_REPRESENTATIVE_ALREADY_EXISTS_FIELD_NUMBER: _ClassVar[int]
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        contact_representative_already_exists: CreateContactRepresentativeReply.Exception.ContactRepresentativeAlreadyExists
        contact_does_not_exist: CreateContactRepresentativeReply.Exception.ContactDoesNotExist
        invalid_data: CreateContactRepresentativeReply.Exception.InvalidData
        def __init__(self, contact_representative_already_exists: _Optional[_Union[CreateContactRepresentativeReply.Exception.ContactRepresentativeAlreadyExists, _Mapping]] = ..., contact_does_not_exist: _Optional[_Union[CreateContactRepresentativeReply.Exception.ContactDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[CreateContactRepresentativeReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: CreateContactRepresentativeReply.Data
    exception: CreateContactRepresentativeReply.Exception
    def __init__(self, data: _Optional[_Union[CreateContactRepresentativeReply.Data, _Mapping]] = ..., exception: _Optional[_Union[CreateContactRepresentativeReply.Exception, _Mapping]] = ...) -> None: ...

class UpdateContactRepresentativeRequest(_message.Message):
    __slots__ = ("id", "name", "organization", "place", "telephone", "email", "log_entry_id")
    ID_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
    PLACE_FIELD_NUMBER: _ClassVar[int]
    TELEPHONE_FIELD_NUMBER: _ClassVar[int]
    EMAIL_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    id: _contact_representative_common_types_pb2.ContactRepresentativeId
    name: str
    organization: str
    place: _common_types_pb2.PlaceAddress
    telephone: _common_types_pb2.PhoneNumber
    email: _common_types_pb2.EmailAddress
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, id: _Optional[_Union[_contact_representative_common_types_pb2.ContactRepresentativeId, _Mapping]] = ..., name: _Optional[str] = ..., organization: _Optional[str] = ..., place: _Optional[_Union[_common_types_pb2.PlaceAddress, _Mapping]] = ..., telephone: _Optional[_Union[_common_types_pb2.PhoneNumber, _Mapping]] = ..., email: _Optional[_Union[_common_types_pb2.EmailAddress, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class UpdateContactRepresentativeReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_representative",)
        CONTACT_REPRESENTATIVE_FIELD_NUMBER: _ClassVar[int]
        contact_representative: _contact_representative_common_types_pb2.ContactRepresentativeInfo
        def __init__(self, contact_representative: _Optional[_Union[_contact_representative_common_types_pb2.ContactRepresentativeInfo, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_representative_does_not_exist", "invalid_data")
        class ContactRepresentativeDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        class InvalidData(_message.Message):
            __slots__ = ("fields",)
            FIELDS_FIELD_NUMBER: _ClassVar[int]
            fields: _containers.RepeatedScalarFieldContainer[str]
            def __init__(self, fields: _Optional[_Iterable[str]] = ...) -> None: ...
        CONTACT_REPRESENTATIVE_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        contact_representative_does_not_exist: UpdateContactRepresentativeReply.Exception.ContactRepresentativeDoesNotExist
        invalid_data: UpdateContactRepresentativeReply.Exception.InvalidData
        def __init__(self, contact_representative_does_not_exist: _Optional[_Union[UpdateContactRepresentativeReply.Exception.ContactRepresentativeDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[UpdateContactRepresentativeReply.Exception.InvalidData, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: UpdateContactRepresentativeReply.Data
    exception: UpdateContactRepresentativeReply.Exception
    def __init__(self, data: _Optional[_Union[UpdateContactRepresentativeReply.Data, _Mapping]] = ..., exception: _Optional[_Union[UpdateContactRepresentativeReply.Exception, _Mapping]] = ...) -> None: ...

class DeleteContactRepresentativeRequest(_message.Message):
    __slots__ = ("id", "log_entry_id")
    ID_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    id: _contact_representative_common_types_pb2.ContactRepresentativeId
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, id: _Optional[_Union[_contact_representative_common_types_pb2.ContactRepresentativeId, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class DeleteContactRepresentativeReply(_message.Message):
    __slots__ = ("exception",)
    class Exception(_message.Message):
        __slots__ = ("contact_representative_does_not_exist",)
        class ContactRepresentativeDoesNotExist(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        CONTACT_REPRESENTATIVE_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        contact_representative_does_not_exist: DeleteContactRepresentativeReply.Exception.ContactRepresentativeDoesNotExist
        def __init__(self, contact_representative_does_not_exist: _Optional[_Union[DeleteContactRepresentativeReply.Exception.ContactRepresentativeDoesNotExist, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: DeleteContactRepresentativeReply.Exception
    def __init__(self, exception: _Optional[_Union[DeleteContactRepresentativeReply.Exception, _Mapping]] = ...) -> None: ...
