from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry.domain import error_types_pb2 as _error_types_pb2_1
from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class CreateDomainRequest(_message.Message):
    __slots__ = ("fqdn", "by_registrar", "registrant_id", "nsset_id", "keyset_id", "administrative_contacts", "period", "log_entry_id")
    FQDN_FIELD_NUMBER: _ClassVar[int]
    BY_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
    REGISTRANT_ID_FIELD_NUMBER: _ClassVar[int]
    NSSET_ID_FIELD_NUMBER: _ClassVar[int]
    KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
    ADMINISTRATIVE_CONTACTS_FIELD_NUMBER: _ClassVar[int]
    PERIOD_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    fqdn: _domain_common_types_pb2.Fqdn
    by_registrar: _registrar_common_types_pb2.RegistrarHandle
    registrant_id: _contact_common_types_pb2.ContactId
    nsset_id: _nsset_common_types_pb2.NssetId
    keyset_id: _keyset_common_types_pb2.KeysetId
    administrative_contacts: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactId]
    period: _domain_common_types_pb2.DomainRegistrationPeriod
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, fqdn: _Optional[_Union[_domain_common_types_pb2.Fqdn, _Mapping]] = ..., by_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., registrant_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., administrative_contacts: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactId, _Mapping]]] = ..., period: _Optional[_Union[_domain_common_types_pb2.DomainRegistrationPeriod, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class CreateDomainReply(_message.Message):
    __slots__ = ("data", "error")
    class Data(_message.Message):
        __slots__ = ("domain_id",)
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        domain_id: _domain_common_types_pb2.DomainId
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ...) -> None: ...
    class Error(_message.Message):
        __slots__ = ("reasons",)
        class Reason(_message.Message):
            __slots__ = ("billing_error", "contact_blocked", "contact_does_not_exist", "invalid_administrative_contacts", "invalid_period", "invalid_fqdn", "invalid_value", "keyset_blocked", "keyset_does_not_exist", "nsset_does_not_exist", "permission_denied", "registrar_does_not_exist")
            BILLING_ERROR_FIELD_NUMBER: _ClassVar[int]
            CONTACT_BLOCKED_FIELD_NUMBER: _ClassVar[int]
            CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            INVALID_ADMINISTRATIVE_CONTACTS_FIELD_NUMBER: _ClassVar[int]
            INVALID_PERIOD_FIELD_NUMBER: _ClassVar[int]
            INVALID_FQDN_FIELD_NUMBER: _ClassVar[int]
            INVALID_VALUE_FIELD_NUMBER: _ClassVar[int]
            KEYSET_BLOCKED_FIELD_NUMBER: _ClassVar[int]
            KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            NSSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            PERMISSION_DENIED_FIELD_NUMBER: _ClassVar[int]
            REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            billing_error: _error_types_pb2.BillingError
            contact_blocked: _error_types_pb2.ContactBlocked
            contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
            invalid_administrative_contacts: _error_types_pb2.InvalidSequence
            invalid_period: _error_types_pb2_1.InvalidDomainRegistrationPeriod
            invalid_fqdn: _error_types_pb2_1.InvalidFqdn
            invalid_value: _error_types_pb2.InvalidValue
            keyset_blocked: _error_types_pb2.KeysetBlocked
            keyset_does_not_exist: _error_types_pb2.KeysetDoesNotExist
            nsset_does_not_exist: _error_types_pb2.NssetDoesNotExist
            permission_denied: _error_types_pb2.PermissionDenied
            registrar_does_not_exist: _error_types_pb2.RegistrarDoesNotExist
            def __init__(self, billing_error: _Optional[_Union[_error_types_pb2.BillingError, _Mapping]] = ..., contact_blocked: _Optional[_Union[_error_types_pb2.ContactBlocked, _Mapping]] = ..., contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ..., invalid_administrative_contacts: _Optional[_Union[_error_types_pb2.InvalidSequence, _Mapping]] = ..., invalid_period: _Optional[_Union[_error_types_pb2_1.InvalidDomainRegistrationPeriod, _Mapping]] = ..., invalid_fqdn: _Optional[_Union[_error_types_pb2_1.InvalidFqdn, _Mapping]] = ..., invalid_value: _Optional[_Union[_error_types_pb2.InvalidValue, _Mapping]] = ..., keyset_blocked: _Optional[_Union[_error_types_pb2.KeysetBlocked, _Mapping]] = ..., keyset_does_not_exist: _Optional[_Union[_error_types_pb2.KeysetDoesNotExist, _Mapping]] = ..., nsset_does_not_exist: _Optional[_Union[_error_types_pb2.NssetDoesNotExist, _Mapping]] = ..., permission_denied: _Optional[_Union[_error_types_pb2.PermissionDenied, _Mapping]] = ..., registrar_does_not_exist: _Optional[_Union[_error_types_pb2.RegistrarDoesNotExist, _Mapping]] = ...) -> None: ...
        REASONS_FIELD_NUMBER: _ClassVar[int]
        reasons: _containers.RepeatedCompositeFieldContainer[CreateDomainReply.Error.Reason]
        def __init__(self, reasons: _Optional[_Iterable[_Union[CreateDomainReply.Error.Reason, _Mapping]]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    data: CreateDomainReply.Data
    error: CreateDomainReply.Error
    def __init__(self, data: _Optional[_Union[CreateDomainReply.Data, _Mapping]] = ..., error: _Optional[_Union[CreateDomainReply.Error, _Mapping]] = ...) -> None: ...
