from fred_api.registry import common_types_pb2 as _common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class DomainContactRole(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    role_unspecified: _ClassVar[DomainContactRole]
    role_registrant: _ClassVar[DomainContactRole]
    role_administrative: _ClassVar[DomainContactRole]
    role_keyset_technical: _ClassVar[DomainContactRole]
    role_nsset_technical: _ClassVar[DomainContactRole]
role_unspecified: DomainContactRole
role_registrant: DomainContactRole
role_administrative: DomainContactRole
role_keyset_technical: DomainContactRole
role_nsset_technical: DomainContactRole

class DomainId(_message.Message):
    __slots__ = ("uuid",)
    UUID_FIELD_NUMBER: _ClassVar[int]
    uuid: _common_types_pb2.Uuid
    def __init__(self, uuid: _Optional[_Union[_common_types_pb2.Uuid, _Mapping]] = ...) -> None: ...

class DomainHistoryId(_message.Message):
    __slots__ = ("uuid",)
    UUID_FIELD_NUMBER: _ClassVar[int]
    uuid: _common_types_pb2.Uuid
    def __init__(self, uuid: _Optional[_Union[_common_types_pb2.Uuid, _Mapping]] = ...) -> None: ...

class Fqdn(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class DomainRef(_message.Message):
    __slots__ = ("id", "fqdn")
    ID_FIELD_NUMBER: _ClassVar[int]
    FQDN_FIELD_NUMBER: _ClassVar[int]
    id: DomainId
    fqdn: Fqdn
    def __init__(self, id: _Optional[_Union[DomainId, _Mapping]] = ..., fqdn: _Optional[_Union[Fqdn, _Mapping]] = ...) -> None: ...

class DomainHistoryInterval(_message.Message):
    __slots__ = ("lower_limit", "upper_limit")
    class Limit(_message.Message):
        __slots__ = ("timestamp", "domain_history_id")
        TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        timestamp: _timestamp_pb2.Timestamp
        domain_history_id: DomainHistoryId
        def __init__(self, timestamp: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., domain_history_id: _Optional[_Union[DomainHistoryId, _Mapping]] = ...) -> None: ...
    LOWER_LIMIT_FIELD_NUMBER: _ClassVar[int]
    UPPER_LIMIT_FIELD_NUMBER: _ClassVar[int]
    lower_limit: DomainHistoryInterval.Limit
    upper_limit: DomainHistoryInterval.Limit
    def __init__(self, lower_limit: _Optional[_Union[DomainHistoryInterval.Limit, _Mapping]] = ..., upper_limit: _Optional[_Union[DomainHistoryInterval.Limit, _Mapping]] = ...) -> None: ...

class DomainStateFlagRequest(_message.Message):
    __slots__ = ("uuid",)
    UUID_FIELD_NUMBER: _ClassVar[int]
    uuid: _common_types_pb2.Uuid
    def __init__(self, uuid: _Optional[_Union[_common_types_pb2.Uuid, _Mapping]] = ...) -> None: ...

class DomainRegistrationPeriod(_message.Message):
    __slots__ = ("months",)
    MONTHS_FIELD_NUMBER: _ClassVar[int]
    months: int
    def __init__(self, months: _Optional[int] = ...) -> None: ...
