from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry import pagination_pb2 as _pagination_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class DomainsByContactRequest(_message.Message):
    __slots__ = ("contact_id", "pagination", "order_by", "fqdn_filter", "include_holder", "include_admin_contact", "include_keyset_tech_contact", "include_nsset_tech_contact", "include_deleted_domains")
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    PAGINATION_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    FQDN_FILTER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_HOLDER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_ADMIN_CONTACT_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_KEYSET_TECH_CONTACT_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_NSSET_TECH_CONTACT_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_DELETED_DOMAINS_FIELD_NUMBER: _ClassVar[int]
    contact_id: _contact_common_types_pb2.ContactId
    pagination: _pagination_pb2.PaginationRequest
    order_by: str
    fqdn_filter: str
    include_holder: bool
    include_admin_contact: bool
    include_keyset_tech_contact: bool
    include_nsset_tech_contact: bool
    include_deleted_domains: bool
    def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationRequest, _Mapping]] = ..., order_by: _Optional[str] = ..., fqdn_filter: _Optional[str] = ..., include_holder: bool = ..., include_admin_contact: bool = ..., include_keyset_tech_contact: bool = ..., include_nsset_tech_contact: bool = ..., include_deleted_domains: bool = ...) -> None: ...

class DomainsByContactReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("domains", "pagination")
        class Domain(_message.Message):
            __slots__ = ("domain_id", "domain", "domain_history_id", "is_holder", "is_admin_contact", "is_keyset_tech_contact", "is_nsset_tech_contact", "is_deleted")
            DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
            IS_HOLDER_FIELD_NUMBER: _ClassVar[int]
            IS_ADMIN_CONTACT_FIELD_NUMBER: _ClassVar[int]
            IS_KEYSET_TECH_CONTACT_FIELD_NUMBER: _ClassVar[int]
            IS_NSSET_TECH_CONTACT_FIELD_NUMBER: _ClassVar[int]
            IS_DELETED_FIELD_NUMBER: _ClassVar[int]
            domain_id: _domain_common_types_pb2.DomainId
            domain: _domain_common_types_pb2.DomainRef
            domain_history_id: _domain_common_types_pb2.DomainHistoryId
            is_holder: bool
            is_admin_contact: bool
            is_keyset_tech_contact: bool
            is_nsset_tech_contact: bool
            is_deleted: bool
            def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain: _Optional[_Union[_domain_common_types_pb2.DomainRef, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ..., is_holder: bool = ..., is_admin_contact: bool = ..., is_keyset_tech_contact: bool = ..., is_nsset_tech_contact: bool = ..., is_deleted: bool = ...) -> None: ...
        DOMAINS_FIELD_NUMBER: _ClassVar[int]
        PAGINATION_FIELD_NUMBER: _ClassVar[int]
        domains: _containers.RepeatedCompositeFieldContainer[DomainsByContactReply.Data.Domain]
        pagination: _pagination_pb2.PaginationReply
        def __init__(self, domains: _Optional[_Iterable[_Union[DomainsByContactReply.Data.Domain, _Mapping]]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationReply, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist", "invalid_order_by")
        class InvalidOrderBy(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_ORDER_BY_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
        invalid_order_by: DomainsByContactReply.Exception.InvalidOrderBy
        def __init__(self, contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ..., invalid_order_by: _Optional[_Union[DomainsByContactReply.Exception.InvalidOrderBy, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: DomainsByContactReply.Data
    exception: DomainsByContactReply.Exception
    def __init__(self, data: _Optional[_Union[DomainsByContactReply.Data, _Mapping]] = ..., exception: _Optional[_Union[DomainsByContactReply.Exception, _Mapping]] = ...) -> None: ...
