from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry import pagination_pb2 as _pagination_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ListDomainsByContactRequest(_message.Message):
    __slots__ = ("contact_id", "contact_snapshot_id", "pagination", "order_by", "aggregate_entire_history", "fqdn_filter", "role_filters")
    class OrderByField(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        order_by_field_unspecified: _ClassVar[ListDomainsByContactRequest.OrderByField]
        order_by_field_crdate: _ClassVar[ListDomainsByContactRequest.OrderByField]
        order_by_field_exdate: _ClassVar[ListDomainsByContactRequest.OrderByField]
        order_by_field_fqdn: _ClassVar[ListDomainsByContactRequest.OrderByField]
        order_by_field_sponsoring_registrar_handle: _ClassVar[ListDomainsByContactRequest.OrderByField]
    order_by_field_unspecified: ListDomainsByContactRequest.OrderByField
    order_by_field_crdate: ListDomainsByContactRequest.OrderByField
    order_by_field_exdate: ListDomainsByContactRequest.OrderByField
    order_by_field_fqdn: ListDomainsByContactRequest.OrderByField
    order_by_field_sponsoring_registrar_handle: ListDomainsByContactRequest.OrderByField
    class OrderBy(_message.Message):
        __slots__ = ("field", "direction")
        FIELD_FIELD_NUMBER: _ClassVar[int]
        DIRECTION_FIELD_NUMBER: _ClassVar[int]
        field: ListDomainsByContactRequest.OrderByField
        direction: _common_types_pb2.OrderByDirection
        def __init__(self, field: _Optional[_Union[ListDomainsByContactRequest.OrderByField, str]] = ..., direction: _Optional[_Union[_common_types_pb2.OrderByDirection, str]] = ...) -> None: ...
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    CONTACT_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    PAGINATION_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    AGGREGATE_ENTIRE_HISTORY_FIELD_NUMBER: _ClassVar[int]
    FQDN_FILTER_FIELD_NUMBER: _ClassVar[int]
    ROLE_FILTERS_FIELD_NUMBER: _ClassVar[int]
    contact_id: _contact_common_types_pb2.ContactId
    contact_snapshot_id: _common_types_pb2.SnapshotId
    pagination: _pagination_pb2.PaginationRequest
    order_by: _containers.RepeatedCompositeFieldContainer[ListDomainsByContactRequest.OrderBy]
    aggregate_entire_history: bool
    fqdn_filter: str
    role_filters: _containers.RepeatedScalarFieldContainer[_domain_common_types_pb2.DomainContactRole]
    def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., contact_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationRequest, _Mapping]] = ..., order_by: _Optional[_Iterable[_Union[ListDomainsByContactRequest.OrderBy, _Mapping]]] = ..., aggregate_entire_history: bool = ..., fqdn_filter: _Optional[str] = ..., role_filters: _Optional[_Iterable[_Union[_domain_common_types_pb2.DomainContactRole, str]]] = ...) -> None: ...

class ListDomainsByContactReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("domains", "pagination", "snapshot_id")
        class Domain(_message.Message):
            __slots__ = ("domain", "domain_history_id", "is_deleted", "roles")
            DOMAIN_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
            IS_DELETED_FIELD_NUMBER: _ClassVar[int]
            ROLES_FIELD_NUMBER: _ClassVar[int]
            domain: _domain_common_types_pb2.DomainRef
            domain_history_id: _domain_common_types_pb2.DomainHistoryId
            is_deleted: bool
            roles: _containers.RepeatedScalarFieldContainer[_domain_common_types_pb2.DomainContactRole]
            def __init__(self, domain: _Optional[_Union[_domain_common_types_pb2.DomainRef, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ..., is_deleted: bool = ..., roles: _Optional[_Iterable[_Union[_domain_common_types_pb2.DomainContactRole, str]]] = ...) -> None: ...
        DOMAINS_FIELD_NUMBER: _ClassVar[int]
        PAGINATION_FIELD_NUMBER: _ClassVar[int]
        SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
        domains: _containers.RepeatedCompositeFieldContainer[ListDomainsByContactReply.Data.Domain]
        pagination: _pagination_pb2.PaginationReply
        snapshot_id: _common_types_pb2.SnapshotId
        def __init__(self, domains: _Optional[_Iterable[_Union[ListDomainsByContactReply.Data.Domain, _Mapping]]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationReply, _Mapping]] = ..., snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist", "invalid_data", "invalid_snapshot")
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
        invalid_data: _error_types_pb2.InvalidData
        invalid_snapshot: _error_types_pb2.InvalidSnapshot
        def __init__(self, contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_error_types_pb2.InvalidData, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ListDomainsByContactReply.Data
    exception: ListDomainsByContactReply.Exception
    def __init__(self, data: _Optional[_Union[ListDomainsByContactReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ListDomainsByContactReply.Exception, _Mapping]] = ...) -> None: ...
