from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry import pagination_pb2 as _pagination_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ListDomainsByRegistrantsRequest(_message.Message):
    __slots__ = ("contact_ids", "contacts_snapshot_id", "pagination", "order_by", "fqdn_filter", "is_outzone", "is_deleted")
    class OrderByField(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        order_by_field_unspecified: _ClassVar[ListDomainsByRegistrantsRequest.OrderByField]
        order_by_field_crdate: _ClassVar[ListDomainsByRegistrantsRequest.OrderByField]
        order_by_field_exdate: _ClassVar[ListDomainsByRegistrantsRequest.OrderByField]
        order_by_field_fqdn: _ClassVar[ListDomainsByRegistrantsRequest.OrderByField]
        order_by_field_sponsoring_registrar_handle: _ClassVar[ListDomainsByRegistrantsRequest.OrderByField]
    order_by_field_unspecified: ListDomainsByRegistrantsRequest.OrderByField
    order_by_field_crdate: ListDomainsByRegistrantsRequest.OrderByField
    order_by_field_exdate: ListDomainsByRegistrantsRequest.OrderByField
    order_by_field_fqdn: ListDomainsByRegistrantsRequest.OrderByField
    order_by_field_sponsoring_registrar_handle: ListDomainsByRegistrantsRequest.OrderByField
    class OrderBy(_message.Message):
        __slots__ = ("field", "direction")
        FIELD_FIELD_NUMBER: _ClassVar[int]
        DIRECTION_FIELD_NUMBER: _ClassVar[int]
        field: ListDomainsByRegistrantsRequest.OrderByField
        direction: _common_types_pb2.OrderByDirection
        def __init__(self, field: _Optional[_Union[ListDomainsByRegistrantsRequest.OrderByField, str]] = ..., direction: _Optional[_Union[_common_types_pb2.OrderByDirection, str]] = ...) -> None: ...
    CONTACT_IDS_FIELD_NUMBER: _ClassVar[int]
    CONTACTS_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    PAGINATION_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    FQDN_FILTER_FIELD_NUMBER: _ClassVar[int]
    IS_OUTZONE_FIELD_NUMBER: _ClassVar[int]
    IS_DELETED_FIELD_NUMBER: _ClassVar[int]
    contact_ids: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactId]
    contacts_snapshot_id: _common_types_pb2.SnapshotId
    pagination: _pagination_pb2.PaginationRequest
    order_by: _containers.RepeatedCompositeFieldContainer[ListDomainsByRegistrantsRequest.OrderBy]
    fqdn_filter: str
    is_outzone: bool
    is_deleted: bool
    def __init__(self, contact_ids: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactId, _Mapping]]] = ..., contacts_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationRequest, _Mapping]] = ..., order_by: _Optional[_Iterable[_Union[ListDomainsByRegistrantsRequest.OrderBy, _Mapping]]] = ..., fqdn_filter: _Optional[str] = ..., is_outzone: bool = ..., is_deleted: bool = ...) -> None: ...

class ListDomainsByRegistrantsReply(_message.Message):
    __slots__ = ("data", "error")
    class Data(_message.Message):
        __slots__ = ("domains", "snapshot_id", "pagination")
        class Domain(_message.Message):
            __slots__ = ("domain", "is_deleted", "domain_history_id", "registrant")
            DOMAIN_FIELD_NUMBER: _ClassVar[int]
            IS_DELETED_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
            REGISTRANT_FIELD_NUMBER: _ClassVar[int]
            domain: _domain_common_types_pb2.DomainRef
            is_deleted: bool
            domain_history_id: _domain_common_types_pb2.DomainHistoryId
            registrant: _contact_common_types_pb2.ContactId
            def __init__(self, domain: _Optional[_Union[_domain_common_types_pb2.DomainRef, _Mapping]] = ..., is_deleted: bool = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ..., registrant: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ...) -> None: ...
        DOMAINS_FIELD_NUMBER: _ClassVar[int]
        SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
        PAGINATION_FIELD_NUMBER: _ClassVar[int]
        domains: _containers.RepeatedCompositeFieldContainer[ListDomainsByRegistrantsReply.Data.Domain]
        snapshot_id: _common_types_pb2.SnapshotId
        pagination: _pagination_pb2.PaginationReply
        def __init__(self, domains: _Optional[_Iterable[_Union[ListDomainsByRegistrantsReply.Data.Domain, _Mapping]]] = ..., snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationReply, _Mapping]] = ...) -> None: ...
    class Error(_message.Message):
        __slots__ = ("reasons",)
        class Reason(_message.Message):
            __slots__ = ("contact_does_not_exist", "invalid_data", "invalid_snapshot")
            CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
            INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
            contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
            invalid_data: _error_types_pb2.InvalidData
            invalid_snapshot: _error_types_pb2.InvalidSnapshot
            def __init__(self, contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_error_types_pb2.InvalidData, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ...) -> None: ...
        REASONS_FIELD_NUMBER: _ClassVar[int]
        reasons: _containers.RepeatedCompositeFieldContainer[ListDomainsByRegistrantsReply.Error.Reason]
        def __init__(self, reasons: _Optional[_Iterable[_Union[ListDomainsByRegistrantsReply.Error.Reason, _Mapping]]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    data: ListDomainsByRegistrantsReply.Data
    error: ListDomainsByRegistrantsReply.Error
    def __init__(self, data: _Optional[_Union[ListDomainsByRegistrantsReply.Data, _Mapping]] = ..., error: _Optional[_Union[ListDomainsByRegistrantsReply.Error, _Mapping]] = ...) -> None: ...
