from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ManageDomainStateFlagsRequest(_message.Message):
    __slots__ = ("by_registrar", "domain_id", "domain_snapshot_id", "create_state_flag_requests", "close_state_flag_requests", "log_entry_id")
    class CreateRequest(_message.Message):
        __slots__ = ("state_flag", "request_id", "valid_from", "valid_to")
        STATE_FLAG_FIELD_NUMBER: _ClassVar[int]
        REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
        VALID_FROM_FIELD_NUMBER: _ClassVar[int]
        VALID_TO_FIELD_NUMBER: _ClassVar[int]
        state_flag: str
        request_id: _common_types_pb2.StateFlagRequestId
        valid_from: _timestamp_pb2.Timestamp
        valid_to: _timestamp_pb2.Timestamp
        def __init__(self, state_flag: _Optional[str] = ..., request_id: _Optional[_Union[_common_types_pb2.StateFlagRequestId, _Mapping]] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    class CloseRequest(_message.Message):
        __slots__ = ("request_id", "valid_to")
        REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
        VALID_TO_FIELD_NUMBER: _ClassVar[int]
        request_id: _common_types_pb2.StateFlagRequestId
        valid_to: _timestamp_pb2.Timestamp
        def __init__(self, request_id: _Optional[_Union[_common_types_pb2.StateFlagRequestId, _Mapping]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    BY_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
    DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
    DOMAIN_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    CREATE_STATE_FLAG_REQUESTS_FIELD_NUMBER: _ClassVar[int]
    CLOSE_STATE_FLAG_REQUESTS_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    by_registrar: _registrar_common_types_pb2.RegistrarHandle
    domain_id: _domain_common_types_pb2.DomainId
    domain_snapshot_id: _common_types_pb2.SnapshotId
    create_state_flag_requests: _containers.RepeatedCompositeFieldContainer[ManageDomainStateFlagsRequest.CreateRequest]
    close_state_flag_requests: _containers.RepeatedCompositeFieldContainer[ManageDomainStateFlagsRequest.CloseRequest]
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, by_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., create_state_flag_requests: _Optional[_Iterable[_Union[ManageDomainStateFlagsRequest.CreateRequest, _Mapping]]] = ..., close_state_flag_requests: _Optional[_Iterable[_Union[ManageDomainStateFlagsRequest.CloseRequest, _Mapping]]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class ManageDomainStateFlagsReply(_message.Message):
    __slots__ = ("data", "error")
    class Data(_message.Message):
        __slots__ = ("request_id", "domain_id", "state_flag")
        REQUEST_ID_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        STATE_FLAG_FIELD_NUMBER: _ClassVar[int]
        request_id: _common_types_pb2.StateFlagRequestId
        domain_id: _domain_common_types_pb2.DomainId
        state_flag: str
        def __init__(self, request_id: _Optional[_Union[_common_types_pb2.StateFlagRequestId, _Mapping]] = ..., domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., state_flag: _Optional[str] = ...) -> None: ...
    class Error(_message.Message):
        __slots__ = ("reasons",)
        class Reason(_message.Message):
            __slots__ = ("domain_does_not_exist", "invalid_value", "invalid_snapshot", "registrar_does_not_exist", "state_flag_does_not_exist", "request_already_exists", "request_does_not_exist")
            DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            INVALID_VALUE_FIELD_NUMBER: _ClassVar[int]
            INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
            REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            STATE_FLAG_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            REQUEST_ALREADY_EXISTS_FIELD_NUMBER: _ClassVar[int]
            REQUEST_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            domain_does_not_exist: _error_types_pb2.DomainDoesNotExist
            invalid_value: _error_types_pb2.InvalidValue
            invalid_snapshot: _error_types_pb2.InvalidSnapshot
            registrar_does_not_exist: _error_types_pb2.RegistrarDoesNotExist
            state_flag_does_not_exist: _error_types_pb2.StateFlagDoesNotExist
            request_already_exists: _error_types_pb2.StateFlagRequestAlreadyExists
            request_does_not_exist: _error_types_pb2.StateFlagRequestDoesNotExist
            def __init__(self, domain_does_not_exist: _Optional[_Union[_error_types_pb2.DomainDoesNotExist, _Mapping]] = ..., invalid_value: _Optional[_Union[_error_types_pb2.InvalidValue, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ..., registrar_does_not_exist: _Optional[_Union[_error_types_pb2.RegistrarDoesNotExist, _Mapping]] = ..., state_flag_does_not_exist: _Optional[_Union[_error_types_pb2.StateFlagDoesNotExist, _Mapping]] = ..., request_already_exists: _Optional[_Union[_error_types_pb2.StateFlagRequestAlreadyExists, _Mapping]] = ..., request_does_not_exist: _Optional[_Union[_error_types_pb2.StateFlagRequestDoesNotExist, _Mapping]] = ...) -> None: ...
        REASONS_FIELD_NUMBER: _ClassVar[int]
        reasons: _containers.RepeatedCompositeFieldContainer[ManageDomainStateFlagsReply.Error.Reason]
        def __init__(self, reasons: _Optional[_Iterable[_Union[ManageDomainStateFlagsReply.Error.Reason, _Mapping]]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    data: ManageDomainStateFlagsReply.Data
    error: ManageDomainStateFlagsReply.Error
    def __init__(self, data: _Optional[_Union[ManageDomainStateFlagsReply.Data, _Mapping]] = ..., error: _Optional[_Union[ManageDomainStateFlagsReply.Error, _Mapping]] = ...) -> None: ...
