from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry import object_events_pb2 as _object_events_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf import empty_pb2 as _empty_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class UpdateDomainRequest(_message.Message):
    __slots__ = ("domain_id", "snapshot_id", "by_registrar", "set_registrant_id", "set_nsset_id", "delete_nsset_id", "set_keyset_id", "delete_keyset_id", "set_administrative_contacts", "log_entry_id")
    class SetContacts(_message.Message):
        __slots__ = ("ids",)
        IDS_FIELD_NUMBER: _ClassVar[int]
        ids: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactId]
        def __init__(self, ids: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactId, _Mapping]]] = ...) -> None: ...
    DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
    SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    BY_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
    SET_REGISTRANT_ID_FIELD_NUMBER: _ClassVar[int]
    SET_NSSET_ID_FIELD_NUMBER: _ClassVar[int]
    DELETE_NSSET_ID_FIELD_NUMBER: _ClassVar[int]
    SET_KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
    DELETE_KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
    SET_ADMINISTRATIVE_CONTACTS_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    domain_id: _domain_common_types_pb2.DomainId
    snapshot_id: _common_types_pb2.SnapshotId
    by_registrar: _registrar_common_types_pb2.RegistrarHandle
    set_registrant_id: _contact_common_types_pb2.ContactId
    set_nsset_id: _nsset_common_types_pb2.NssetId
    delete_nsset_id: _empty_pb2.Empty
    set_keyset_id: _keyset_common_types_pb2.KeysetId
    delete_keyset_id: _empty_pb2.Empty
    set_administrative_contacts: UpdateDomainRequest.SetContacts
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., by_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., set_registrant_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., set_nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., delete_nsset_id: _Optional[_Union[_empty_pb2.Empty, _Mapping]] = ..., set_keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., delete_keyset_id: _Optional[_Union[_empty_pb2.Empty, _Mapping]] = ..., set_administrative_contacts: _Optional[_Union[UpdateDomainRequest.SetContacts, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class UpdateDomainReply(_message.Message):
    __slots__ = ("data", "error")
    class Data(_message.Message):
        __slots__ = ("domain_history_id",)
        DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        domain_history_id: _domain_common_types_pb2.DomainHistoryId
        def __init__(self, domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ...) -> None: ...
    class Error(_message.Message):
        __slots__ = ("reasons",)
        class Reason(_message.Message):
            __slots__ = ("contact_blocked", "contact_does_not_exist", "domain_blocked", "domain_does_not_exist", "invalid_administrative_contacts", "invalid_snapshot", "invalid_value", "keyset_blocked", "keyset_does_not_exist", "nsset_does_not_exist", "permission_denied", "registrar_does_not_exist")
            CONTACT_BLOCKED_FIELD_NUMBER: _ClassVar[int]
            CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_BLOCKED_FIELD_NUMBER: _ClassVar[int]
            DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            INVALID_ADMINISTRATIVE_CONTACTS_FIELD_NUMBER: _ClassVar[int]
            INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
            INVALID_VALUE_FIELD_NUMBER: _ClassVar[int]
            KEYSET_BLOCKED_FIELD_NUMBER: _ClassVar[int]
            KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            NSSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            PERMISSION_DENIED_FIELD_NUMBER: _ClassVar[int]
            REGISTRAR_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
            contact_blocked: _error_types_pb2.ContactBlocked
            contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
            domain_blocked: _error_types_pb2.DomainBlocked
            domain_does_not_exist: _error_types_pb2.DomainDoesNotExist
            invalid_administrative_contacts: _error_types_pb2.InvalidSequence
            invalid_snapshot: _error_types_pb2.InvalidSnapshot
            invalid_value: _error_types_pb2.InvalidValue
            keyset_blocked: _error_types_pb2.KeysetBlocked
            keyset_does_not_exist: _error_types_pb2.KeysetDoesNotExist
            nsset_does_not_exist: _error_types_pb2.NssetDoesNotExist
            permission_denied: _error_types_pb2.PermissionDenied
            registrar_does_not_exist: _error_types_pb2.RegistrarDoesNotExist
            def __init__(self, contact_blocked: _Optional[_Union[_error_types_pb2.ContactBlocked, _Mapping]] = ..., contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ..., domain_blocked: _Optional[_Union[_error_types_pb2.DomainBlocked, _Mapping]] = ..., domain_does_not_exist: _Optional[_Union[_error_types_pb2.DomainDoesNotExist, _Mapping]] = ..., invalid_administrative_contacts: _Optional[_Union[_error_types_pb2.InvalidSequence, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ..., invalid_value: _Optional[_Union[_error_types_pb2.InvalidValue, _Mapping]] = ..., keyset_blocked: _Optional[_Union[_error_types_pb2.KeysetBlocked, _Mapping]] = ..., keyset_does_not_exist: _Optional[_Union[_error_types_pb2.KeysetDoesNotExist, _Mapping]] = ..., nsset_does_not_exist: _Optional[_Union[_error_types_pb2.NssetDoesNotExist, _Mapping]] = ..., permission_denied: _Optional[_Union[_error_types_pb2.PermissionDenied, _Mapping]] = ..., registrar_does_not_exist: _Optional[_Union[_error_types_pb2.RegistrarDoesNotExist, _Mapping]] = ...) -> None: ...
        REASONS_FIELD_NUMBER: _ClassVar[int]
        reasons: _containers.RepeatedCompositeFieldContainer[UpdateDomainReply.Error.Reason]
        def __init__(self, reasons: _Optional[_Iterable[_Union[UpdateDomainReply.Error.Reason, _Mapping]]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    data: UpdateDomainReply.Data
    error: UpdateDomainReply.Error
    def __init__(self, data: _Optional[_Union[UpdateDomainReply.Data, _Mapping]] = ..., error: _Optional[_Union[UpdateDomainReply.Error, _Mapping]] = ...) -> None: ...
