from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from fred_api.registry import pagination_pb2 as _pagination_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class ListNssetsByContactRequest(_message.Message):
    __slots__ = ("contact_id", "contact_snapshot_id", "pagination", "order_by", "aggregate_entire_history")
    class OrderByField(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        order_by_field_unspecified: _ClassVar[ListNssetsByContactRequest.OrderByField]
        order_by_field_crdate: _ClassVar[ListNssetsByContactRequest.OrderByField]
        order_by_field_handle: _ClassVar[ListNssetsByContactRequest.OrderByField]
        order_by_field_domains_count: _ClassVar[ListNssetsByContactRequest.OrderByField]
        order_by_field_sponsoring_registrar_handle: _ClassVar[ListNssetsByContactRequest.OrderByField]
    order_by_field_unspecified: ListNssetsByContactRequest.OrderByField
    order_by_field_crdate: ListNssetsByContactRequest.OrderByField
    order_by_field_handle: ListNssetsByContactRequest.OrderByField
    order_by_field_domains_count: ListNssetsByContactRequest.OrderByField
    order_by_field_sponsoring_registrar_handle: ListNssetsByContactRequest.OrderByField
    class OrderBy(_message.Message):
        __slots__ = ("field", "direction")
        FIELD_FIELD_NUMBER: _ClassVar[int]
        DIRECTION_FIELD_NUMBER: _ClassVar[int]
        field: ListNssetsByContactRequest.OrderByField
        direction: _common_types_pb2.OrderByDirection
        def __init__(self, field: _Optional[_Union[ListNssetsByContactRequest.OrderByField, str]] = ..., direction: _Optional[_Union[_common_types_pb2.OrderByDirection, str]] = ...) -> None: ...
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    CONTACT_SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
    PAGINATION_FIELD_NUMBER: _ClassVar[int]
    ORDER_BY_FIELD_NUMBER: _ClassVar[int]
    AGGREGATE_ENTIRE_HISTORY_FIELD_NUMBER: _ClassVar[int]
    contact_id: _contact_common_types_pb2.ContactId
    contact_snapshot_id: _common_types_pb2.SnapshotId
    pagination: _pagination_pb2.PaginationRequest
    order_by: _containers.RepeatedCompositeFieldContainer[ListNssetsByContactRequest.OrderBy]
    aggregate_entire_history: bool
    def __init__(self, contact_id: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., contact_snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationRequest, _Mapping]] = ..., order_by: _Optional[_Iterable[_Union[ListNssetsByContactRequest.OrderBy, _Mapping]]] = ..., aggregate_entire_history: bool = ...) -> None: ...

class ListNssetsByContactReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("nssets", "pagination", "snapshot_id")
        class Nsset(_message.Message):
            __slots__ = ("nsset", "nsset_history_id", "is_deleted")
            NSSET_FIELD_NUMBER: _ClassVar[int]
            NSSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
            IS_DELETED_FIELD_NUMBER: _ClassVar[int]
            nsset: _nsset_common_types_pb2.NssetRef
            nsset_history_id: _nsset_common_types_pb2.NssetHistoryId
            is_deleted: bool
            def __init__(self, nsset: _Optional[_Union[_nsset_common_types_pb2.NssetRef, _Mapping]] = ..., nsset_history_id: _Optional[_Union[_nsset_common_types_pb2.NssetHistoryId, _Mapping]] = ..., is_deleted: bool = ...) -> None: ...
        NSSETS_FIELD_NUMBER: _ClassVar[int]
        PAGINATION_FIELD_NUMBER: _ClassVar[int]
        SNAPSHOT_ID_FIELD_NUMBER: _ClassVar[int]
        nssets: _containers.RepeatedCompositeFieldContainer[ListNssetsByContactReply.Data.Nsset]
        pagination: _pagination_pb2.PaginationReply
        snapshot_id: _common_types_pb2.SnapshotId
        def __init__(self, nssets: _Optional[_Iterable[_Union[ListNssetsByContactReply.Data.Nsset, _Mapping]]] = ..., pagination: _Optional[_Union[_pagination_pb2.PaginationReply, _Mapping]] = ..., snapshot_id: _Optional[_Union[_common_types_pb2.SnapshotId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist", "invalid_data", "invalid_snapshot")
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_DATA_FIELD_NUMBER: _ClassVar[int]
        INVALID_SNAPSHOT_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _error_types_pb2.ContactDoesNotExist
        invalid_data: _error_types_pb2.InvalidData
        invalid_snapshot: _error_types_pb2.InvalidSnapshot
        def __init__(self, contact_does_not_exist: _Optional[_Union[_error_types_pb2.ContactDoesNotExist, _Mapping]] = ..., invalid_data: _Optional[_Union[_error_types_pb2.InvalidData, _Mapping]] = ..., invalid_snapshot: _Optional[_Union[_error_types_pb2.InvalidSnapshot, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: ListNssetsByContactReply.Data
    exception: ListNssetsByContactReply.Exception
    def __init__(self, data: _Optional[_Union[ListNssetsByContactReply.Data, _Mapping]] = ..., exception: _Optional[_Union[ListNssetsByContactReply.Exception, _Mapping]] = ...) -> None: ...
