from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import error_types_pb2 as _error_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class NssetHistoryRequest(_message.Message):
    __slots__ = ("nsset_id", "history")
    NSSET_ID_FIELD_NUMBER: _ClassVar[int]
    HISTORY_FIELD_NUMBER: _ClassVar[int]
    nsset_id: _nsset_common_types_pb2.NssetId
    history: _nsset_common_types_pb2.NssetHistoryInterval
    def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., history: _Optional[_Union[_nsset_common_types_pb2.NssetHistoryInterval, _Mapping]] = ...) -> None: ...

class NssetHistoryRecord(_message.Message):
    __slots__ = ("nsset_history_id", "valid_from", "log_entry_id")
    NSSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    nsset_history_id: _nsset_common_types_pb2.NssetHistoryId
    valid_from: _timestamp_pb2.Timestamp
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, nsset_history_id: _Optional[_Union[_nsset_common_types_pb2.NssetHistoryId, _Mapping]] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class NssetHistoryReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("nsset_id", "timeline", "valid_to")
        NSSET_ID_FIELD_NUMBER: _ClassVar[int]
        TIMELINE_FIELD_NUMBER: _ClassVar[int]
        VALID_TO_FIELD_NUMBER: _ClassVar[int]
        nsset_id: _nsset_common_types_pb2.NssetId
        timeline: _containers.RepeatedCompositeFieldContainer[NssetHistoryRecord]
        valid_to: _timestamp_pb2.Timestamp
        def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., timeline: _Optional[_Iterable[_Union[NssetHistoryRecord, _Mapping]]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("nsset_does_not_exist", "invalid_history_interval")
        class InvalidHistoryInterval(_message.Message):
            __slots__ = ()
            def __init__(self) -> None: ...
        NSSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        INVALID_HISTORY_INTERVAL_FIELD_NUMBER: _ClassVar[int]
        nsset_does_not_exist: _error_types_pb2.NssetDoesNotExist
        invalid_history_interval: NssetHistoryReply.Exception.InvalidHistoryInterval
        def __init__(self, nsset_does_not_exist: _Optional[_Union[_error_types_pb2.NssetDoesNotExist, _Mapping]] = ..., invalid_history_interval: _Optional[_Union[NssetHistoryReply.Exception.InvalidHistoryInterval, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: NssetHistoryReply.Data
    exception: NssetHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[NssetHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[NssetHistoryReply.Exception, _Mapping]] = ...) -> None: ...
